function N = Deinterleave(n)
% Synopsis: 
% N = Deinterleave(n); 
% where
% n is the box number in the hierarchical 2^DIM-tree
% N is the vector of length DIM (Cartesian coordinates of n)
% DIM is the dimensionality of the space (described as global)

% written by 
% Nail Gumerov, gumerov@umiacs.umd.edu
% Eugene Borovikov, yab@umiacs.umd.edu 
% on May 15, 2002

global DIM

N=zeros(DIM,1);

k=0;
i=0;

while n
    j=DIM-k;
    N(j)=bitor(N(j),bitshift(bitget(n,1),i));
    n=bitshift(n,-1);
    k=mod(k+1,DIM);
    if(~k)
        i=i+1;
    end;    
end;    