function n = Interleave(N)
% Synopsis: 
% n = Interleave(N); 
% where
% n is the box number in the hierarchical 2^DIM-tree
% N is the vector of length DIM (Cartesian coordinates of n)
% DIM is the dimensionality of the space (described as global)

% written by 
% Nail Gumerov, gumerov@umiacs.umd.edu
% Eugene Borovikov, yab@umiacs.umd.edu 
% on May 15, 2002

global DIM

k=0;
i=0;
n=0;

while sum(N)
    j=DIM-k;
    n=bitor(bitshift(bitget(N(j),1),i),n);
    N(j)=bitshift(N(j),-1);
    k=mod(k+1,DIM);
    i=i+1;
end;