function N = NeighborsAll(n,level)
% Synopsis: 
% N=NeighborsAll(n,level); 
% where
% (n,level) is the global box adress in the hierarchical 2^DIM-tree
% N is the sorted set of neighbors
% DIM is the dimensionality of the space (described as global)

% written by 
% Nail Gumerov, gumerov@umiacs.umd.edu
% Eugene Borovikov, yab@umiacs.umd.edu 
% on May 15, 2002

global DIM

N=[];
Ncoord0=Deinterleave(n)-1;
OdometerState=zeros(DIM,1);
MaxNeighbors=3^DIM-1;
MaxCoord=2^level-1;

for i=0:MaxNeighbors,  
    Ncoord=Ncoord0+OdometerState;
    if ((Ncoord>=0) & (Ncoord<=MaxCoord))
        N=union(N,Interleave(Ncoord));
    end;    
    OdometerState=OdometerNext(OdometerState,3);
end;    

N=setdiff(N,n);