function N=NeighborsE4_(n,level)
% Synopsis: 
% N=NeighborsE4_(n,level); 
% where
% (n,level) is the global box adress in the hierarchical 2^DIM-tree
% N is the sorted set of nonzero neighbors
% DIM is the dimensionality of the space (described as global)
% OrderedData is the sorted global data organized in hierarchy of 2^DIM-tree

% written by 
% Nail Gumerov, gumerov@umiacs.umd.edu
% on October 31, 2002

S=[];
Nei=Neighbors(Parent(n),level-1);
for i=Nei
    S=union(S,Children(i,level-1));
end;    
T=union(Neighbors(n,level),n);
N=setdiff(S,T);