function SetDataStructure(X)

global DIM OrderedData SourceData max_cluster_power PermutIndex
global SizeOfUniverse EpsilonShift XminBoundary

%Determine size and scaling

[DIM,point_count]=size(X);
XminBoundary=min(X');
xmax=max(X');
d=max(xmax-XminBoundary); % The cube dxdxd encloses the set {X}
XminBoundary=[0 0];%remove
d=1;%remove
%SizeOfUniverse=d*(1+EpsilonShift); % the set {X} will be bounded by epsilon-enlarged cube;
%SourceData=(X-meshgrid(XminBoundary,1:point_count)')/SizeOfUniverse;
SourceData=X;

%Initialize the Regular 2^DIM Tree
% written by 
% Nail Gumerov, gumerov@umiacs.umd.edu
% Eugene Borovikov, yab@umiacs.umd.edu 
% on May 15, 2002

max_bits=log2(bitmax)-1;
coord_bit_count=floor(max_bits/DIM);

%--- interleave source pts
m=bitshift(1,coord_bit_count); % succ of max int coord
for i=1:point_count
    OrderedData(1,i)=Interleave(floor(m*SourceData(:,i)));
end
[OrderedData(1,:),PermutIndex]=sort(OrderedData(1,:));

%--- determine max level of subdivision
L=0;
for i=1:point_count-max_cluster_power
    j=coord_bit_count+1;
    p=[OrderedData(1,i) OrderedData(1,i+max_cluster_power)];
    while p(1)~=p(2), j=j-1; p=Parent(p); end;   
    L=max(L,j);
end

%--- truncate pts in OrderedData to L*DIM bit
OrderedData(L,:)=bitshift(OrderedData(1,:),(L-coord_bit_count)*DIM);

%--- form all other levels
for lvl=L:-1:2
    OrderedData(lvl-1,:)=Parent(OrderedData(lvl,:));
end

SourceData=SourceData(:,PermutIndex);